// Sample Ikon Application
#include <ikon.h>          /* ikon.h should ALWAYS be first  */
#include <string.h>
#include <gui.h>

void Exit(int data);
void newtext();
void savetext();
void opentext();
char *loadpath;
char loadfile[80];
int _quit;
int ourwinid;                   /* the id of our window */
int tbid;       //id for the textbox
int cmdflag;    //set if there is a command line to load a file
char *text;	//text in the textbox

void keychecker(int data);

void *var_router(DCM *dcm, int var)
{
  return(0);
}

void options(int option)
{
        if(option==1)
        {
                newtext();
                RefreshTextBox(tbid);
        }
        if(option==2)
        {
                //open
		memset(loadfile,0,sizeof(loadfile));
                FileSelector("*.*",opentext,&loadfile);
        }
        if(option==3)
        {
                //save loaded file
                savetext();
        }
        if(option==4)
        {
                //save as
		memset(loadfile,0,sizeof(loadfile));
                FileSelector("*.*",savetext,&loadfile);
        }
        if(option==5)
        {
                Exit(0);
        }
        RefreshWin(ourwinid);


};

void menu(int data)
{
        PopMenu("New,none,Open,none,Save,none,Save As,none,Exit,none",options);
};

static void appmain()
{
  //*********[ Your main program routine ]****************
        InitGUI();
	text=(char *)malloc(200000);
	if(text==0)
	{
		SystemMessage("Unable to allocate a large\r\nenough buffer.");
		GenEvent(ExitApp,pid);
		return;
	}
	memset(text,0,200000);
        ourwinid=MakeWindow(10,10,700,574,"Ikon Edit 1.0",Exit,0);
        tbid=AddTextBox(ourwinid,4,37,69,38,text);
        MakeLabelButton(ourwinid,SystemFont(),6,22,0,"File",menu,0);
        if(strlen(GetCommand(pid))!=NULL)
        {
                cmdflag=1;
                loadpath=GetCommand(pid);
                strcpy(loadfile,GetCommand(pid));
                opentext();
                cmdflag=0;
        }
        RefreshEditBox(tbid);
        RefreshWin(ourwinid);
        loadpath=loadfile;
	_quit=0;
	GenEvent(keychecker,0);
};

void Exit(int data)
{
	free((void *)text);
        CloseWin(ourwinid);
        ExitApp(pid);
};

void savetext()
{
        char *path;
        int fbuff;
        int temp;
        FILE *filehandle;
        if(strlen(loadfile)<1){return;}
        path=loadpath;
        filehandle=fopen(path,"w");
        temp=0;
        do{
                fbuff=fputc(text[temp],filehandle);
                if(fbuff==EOF)
                        break;
                temp=temp+1;
                if(temp==100000)
                        break;
                if(fbuff==0x00)
                        break;
        }while(fbuff!=EOF);
        fclose(filehandle);
        SetFocusOn(ourwinid);
        RefreshWin(ourwinid);
};

void keychecker(int data)
{
	int key;
	int scancode;
	if(CurrentWindow()!=ourwinid)
		return;
	if(_quit==1)
		return;
	key=GetKey();
	scancode=(key >>8)&0xff;
	if(scancode==KEY_F10)
	{
		_quit=1;
		Exit(0);
		return;
	}
	else
	{
		PutKey(key);
	}
	GenEvent(keychecker,0);
}

void opentext()
{
        int fbuff;
        int temp;
	struct stat st;
        FILE *filehandle;
        newtext();
        if(strlen(loadfile)<1){return;}
	temp=stat(loadfile,&st);
	if(st.st_size>199999)
	{
		SystemMessage(" File too big!");
		return;
	}
        filehandle=fopen(loadfile,"r");
        if(filehandle>0)
        {
        temp=0;
        do{
                fbuff=fgetc(filehandle);
                if(fbuff==0x0d)
                        continue;
                if(fbuff==EOF)
                        break;
                text[temp]=fbuff;
                temp=temp+1;
        }while(fbuff!=EOF);
        fclose(filehandle);
        };
        RefreshTextBox(tbid);
        SetFocusOn(ourwinid);
        RefreshWin(ourwinid);
};

void newtext()
{
        int temp;
        temp=1;
        ResetTextBox(tbid);
	memset(text,0,200000);
        RefreshTextBox(tbid);
        RefreshWin(ourwinid);
};

 